/[BackupPC]/trunk/bin/BackupPC_recover_from_increments
This is repository of my old source code which isn't updated any more. Go to git.rot13.org for current projects!
ViewVC logotype

Diff of /trunk/bin/BackupPC_recover_from_increments

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

revision 340 by dpavlin, Mon Mar 6 20:47:00 2006 UTC revision 356 by dpavlin, Thu Apr 27 09:36:18 2006 UTC
# Line 1  Line 1 
1  #!/usr/bin/perl -w  #!/usr/bin/perl -w
2    
3    use strict;
4    
5  =head1 NAME  =head1 NAME
6    
7  BackupPC_recover_from_increments  BackupPC_recover_from_increments
# Line 19  quick hack to create BackupPC pool out o Line 21  quick hack to create BackupPC pool out o
21  =cut  =cut
22    
23  use File::Find;  use File::Find;
24    use File::Path;
25  use Data::Dumper;  use Data::Dumper;
26    
27  use lib "/data/backuppc/lib";  use lib "/data/backuppc/lib";
28  use BackupPC::Lib;  use BackupPC::Lib;
29    
30    my $host = 'restore';
31    my $share = '/etc';
32    
33  # connect to BackupPC_server  # connect to BackupPC_server
34    
35  die("BackupPC::Lib->new failed\n") if ( !(my $bpc = BackupPC::Lib->new) );  die("BackupPC::Lib->new failed\n") if ( !(my $bpc = BackupPC::Lib->new) );
# Line 39  if ( $err ) { Line 45  if ( $err ) {
45    
46  my $TopDir = $bpc->TopDir();  my $TopDir = $bpc->TopDir();
47    
48  print Dumper(\%Conf);  #print Dumper(\%Conf);
49    
50  # create restore host configuration  # check if host exists
51    
52    my $host_info = $bpc->HostInfoRead( $host );
53    #print Dumper($host_info, $bpc->HostInfoRead( 'localhost' ));
54    die "host '$host' is not found, please add it to config/hosts configuration file\n" unless ($host_info->{$host});
55    
56    # take care of temporary directory for increments
57    
58  my $restore_path = "$TopDir/$temp/restore.tar.gz";  my $inc_tmp_dir = $Conf{IncrementTempDir} || die "need working directory in IncrementTempDir\n";
59    rmtree($inc_tmp_dir) if (-e $inc_tmp_dir);
60    
61    mkpath($inc_tmp_dir);
62    
63    print "# using $inc_tmp_dir for increment scratch space";
64    
65    # create restore host configuration
66    
67  my $conf_restore = <<'_END_OF_CONF_';  my $conf_restore = <<'_END_OF_CONF_';
68    
69  $Conf{XferMethod} = 'tar';  $Conf{XferMethod} = 'tar';
70    $Conf{TarShareName} = '__share__';
71    
72  $Conf{TarFullArgs} = 'echo "full backups are not supported in restore!" ; exit 1';  # disable ping
73  $Conf{TarIncrArgs} = '';  $Conf{PingCmd} = '';
74    # work-around for Backup aborted because of CorrectHostCheck
75  # fake ping when restoring  $Conf{FixedIPNetBiosNameCheck} = 0;
76  $Conf{PingCmd} = '$pingPath -c 1 localhost',  $Conf{NmbLookupCmd} = '';
77    $Conf{ClientNameAlias} = 'localhost';
78    
79    #$Conf{TarIncrArgs} = '';
80    #$Conf{ClientTimeout} = 600;
81    #$Conf{TarClientCmd} = '';
82    #$Conf{TarFullArgs} = 'gzip -cdv __restore_path__';
83    
84  $Conf{TarClientCmd} = 'zcat __restore_path__';  $Conf{TarClientCmd} = '$tarPath -c -v -f - -C __inc_tmp_dir__ --totals';
85    
86  1;  1;
87    
88  _END_OF_CONF_  _END_OF_CONF_
89    
90  $conf_restore =~ s/__restore_path__/$restore_path/gs;  $conf_restore =~ s/__share__/$share/gs;
91    $conf_restore =~ s/__inc_tmp_dir__/$inc_tmp_dir/gs;
92    
93  my $config_file = "$bpc->{TopDir}/conf/restore.pl";  my $config_file = "$bpc->{TopDir}/conf/${host}.pl";
94    
95  open(my $host_fh, '>', $config_file) || die "can't open $config_file: $!";  open(my $host_fh, '>', $config_file) || die "can't open $config_file: $!";
96  print $host_fh $conf_restore || die "can't write configuration in $config_file: $!";  print $host_fh $conf_restore || die "can't write configuration in $config_file: $!";
# Line 74  warn "written config:\n$conf_restore\n"; Line 101  warn "written config:\n$conf_restore\n";
101  sub restore_increment {  sub restore_increment {
102          my $path = shift || die "need path!";          my $path = shift || die "need path!";
103    
104          print "working on $path\n";          if ($path !~ m/\.tar\.gz$/i) {
105                    print "# skipping $path, not .tar.gz increment\n";
106          if (-e $restore_path) {                  return;
                 unlink $restore_path || die "can't remove $restore_path: $!\n";  
107          }          }
         link $path, $restore_path || die "can't create link $path -> $restore_path: $!\n";  
108    
109          $bpc->ServerMesg("log User backuppc started restore of $path");          print "restoring $path\n";
110    
111            my $cmd = "cd $inc_tmp_dir && tar xvfz $path";
112            system($cmd) == 0 or die "can't execute: $cmd -- $?\n";
113    
114            print "starting import into BackupPC pool\n";
115    
116            my $user = $host_info->{$host}->{user} || die "can't get user for host $host";
117    
118            $bpc->ServerMesg("log User $user started recovery from increment $path");
119    
120          my $full = 0;          my @backups = $bpc->BackupInfoRead( $host );
121          my $r = $bpc->ServerMesg("backup restore restore backuppc $full");  
122          print "backup --> $r";          my $full = 1;
123            foreach my $b (@backups) {
124                    $full = 0 if ($b->{type} eq 'full');
125            }
126    
127            my $r = $bpc->ServerMesg("backup $host $host $user $full");
128            print "backup ", $full ? 'full' : 'incremental', " --> $r";
129            die $r if ($r =~ m/^error/);
130    
131          # Status_backup_in_progress          # Status_backup_in_progress
132          # Status_idle          # Status_idle
# Line 99  sub restore_increment { Line 140  sub restore_increment {
140                          eval "$s";                          eval "$s";
141                  }                  }
142                  $state = $Status{restore}->{state};                  $state = $Status{restore}->{state};
143    
144                    die $state if ($state =~ m/^error/);
145    
146                  if ($state ne $last_state) {                  if ($state ne $last_state) {
147                          print "\n$state"; #, Dumper($Status{restore});                          print "\n$state"; #, Dumper($Status{restore});
148                  } else {                  } else {
# Line 120  foreach my $restore_inc (@ARGV) { Line 164  foreach my $restore_inc (@ARGV) {
164                          restore_increment( $File::Find::name );                          restore_increment( $File::Find::name );
165                  }, follow => 0 }, $restore_inc);                  }, follow => 0 }, $restore_inc);
166    
167          } elsif (-f $restore_inc && $restore_inc =~ m/\.tar\.gz$/i) {          } elsif (-f $restore_inc) {
168                  restore_increment( $restore_inc );                  restore_increment( $restore_inc );
169          } else {          } else {
170                  warn "skipped: $restore_inc, not directory or .tar.gz increment\n";                  warn "skipped: $restore_inc, not file or directory\n";
171          }          }
172    
173  }  }

Legend:
Removed from v.340  
changed lines
  Added in v.356

  ViewVC Help
Powered by ViewVC 1.1.26